﻿@using ProyectoFase2.Shared.General;
@using ProyectoFase2.Shared.Models.Paper;
@using ProyectoFase2.Site.Client.ViewModels.Paper;
@using System.Text.Json;
@using System.Text;
@inject INotificationCustomerService NotificationService
@inject IHTTPClientRequestService Http
@inject IJSRuntime JSRuntime
@inject IToolTipCustomer tooltipService
@inject DialogService DialogService

@if (LoadingData)
{
    <RadzenCardLoader IsLoading="@LoadingData">
    </RadzenCardLoader>
}
else
{
    <EditForm Model="@Model" OnValidSubmit="@OnSubmit" OnInvalidSubmit="@OnInvalidSubmit">
        <DataAnnotationsValidator />
        <div class="alert @StatusClass">
            <ValidationSummary />
        </div>
        <div class="row justify-content-left" style="padding-top: 5px">
            <div class="form-group col-lg-6">
                <label for="name">Título del documento: </label>
                <InputText Id="name" Class="form-control" @bind-Value="@Model.Title"></InputText>
                <ValidationMessage For="@(() => Model.Title)" />
            </div>
            <div class="form-group col-lg-6 ">
                <label for="fileInput">Archivo: </label>
                <br>
                <label class="custom-file-button rz-secondary">
                    <InputFile id="fileInput" OnChange="OnInputFileChange" class="input-file" accept=".pdf" maxsize="52428800" />
                    <span class="button-text">Cargar Archivo</span>
                </label>
                @if (Model.BrowserFile != null)
                {
                    <label style="margin-left:5px">@Model.BrowserFile.Name</label>

                }
                <ValidationMessage For="@(() => Model.BrowserFile)" />
            </div>

        </div>

        <div class="row justify-content-left" style="padding-top: 5px">
            <div class="form-group col-lg-12">
                <label for="name">Palabras clave del documento (separar con coma): </label>
                <InputText Id="KeyWords" Class="form-control" @bind-Value="@Model.Keywords"></InputText>
                <ValidationMessage For="@(() => Model.Keywords)" />
            </div>
        </div>

        <div class="row justify-content-left" style="padding-top: 5px">
            <div class="form-group col-lg-6">
                <label for="Description">Descripción del documento: </label>
                <RadzenTextArea @bind-Value="@Model.Description" class="w-100" Style="height: 300px;" />
                <ValidationMessage For="@(() => Model.Description)" />
            </div>
            <div class="form-group col-lg-6">
                <label for="Abstract">Abstract del documento: </label>
                <RadzenTextArea @bind-Value="@Model.Abstract" class="w-100" Style="height: 300px;" />
                <ValidationMessage For="@(() => Model.Abstract)" />
            </div>
        </div>

        <div class="row justify-content-left" style="padding-top: 5px">
            <div class="col-md-3">
                <br />
                <RadzenButton ButtonType="ButtonType.Submit" Text="Crear"></RadzenButton>
            </div>
        </div>
    </EditForm>
}

@code
{

    public bool LoadingData { get; set; } = false;
    public PaperCreateViewModel Model { get; set; } = new();
    public string StatusClass;

    [Parameter]
    public EventCallback GoFirstTab { get; set; }

    private async Task BrowseFiles()
    {
        // Aquí puedes usar JavaScript para hacer clic en el componente InputFile oculto
        await JSRuntime.InvokeVoidAsync("clickInputFile");
    }

    private async Task OnInputFileChange(InputFileChangeEventArgs e)
    {
        LoadingData = true;
        try
        {
            var newFile = e.File;
            if (Path.GetExtension(newFile.Name) != ".pdf")
            {
                NotificationService.Notify("Extensión de archivo no valido! Solo se permiten archivos PDF", NotificationSeverity.Error);
                return;
            }

            int maxAllowedSize = 52428800; //10MB
            if (newFile.Size > maxAllowedSize)
            {
                NotificationService.Notify("Tamaño de archivo no valido! Solo puede cargar archivo máximo de 50MB.", NotificationSeverity.Error);
                return;
            }

            Model.BrowserFile = e.File;

            using (var memoryStream = new MemoryStream())
            {
                await Model.BrowserFile.OpenReadStream(int.MaxValue).CopyToAsync(memoryStream);
                Model.File = memoryStream.ToArray();
            }
            LoadingData = false;
        }
        catch (Exception ex)
        {
            LoadingData = false;
            NotificationService.Notify(ex.Message, NotificationSeverity.Error);
        }
        finally
        {
            StateHasChanged();
        }
    }


    protected override async Task OnInitializedAsync()
    {
        try
        {
            LoadingData = true;
            await this.LoadData();
            LoadingData = false;
        }
        catch (Exception ex)
        {
            NotificationService.Notify(ex.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    public async Task LoadData()
    {
        try
        {
            LoadingData = true;
        }
        catch (Exception ex)
        {
            NotificationService.Notify(ex.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    async Task OnSubmit()
    {
        try
        {
            var result = await DialogService.OpenAsync("Crear", ds =>
    @<div>
        <p Style="margin-bottom: 1rem">¿Esta seguro que desea crear el registro? </p>
        <div class="row">
            <div class="col-md-12">
                <RadzenButton Text="Ok" Click="() => ds.Close(true)" Style="margin-bottom: 10px; width: 150px" />
                <RadzenButton Text="Cancel" Click="() => ds.Close(false)" ButtonStyle="ButtonStyle.Secondary" Style="margin-bottom: 10px; width: 150px" />
            </div>
        </div>
        </div>
    );

            if (result == false)
            {
                return;
            }

            LoadingData = true;

            var objct = new PaperCreateDTO
                {
                    Abstract = Model.Abstract,
                    FileName = Model.BrowserFile.Name,
                    Description = Model.Description,
                    File = Model.File,
                    Keywords = Model.Keywords,
                    Title = Model.Title,
                };
            var resPost = await Http.Post<bool>("api/Paper", objct);

            if (resPost.Succeeded)
            {
                NotificationService.Notify("Se creó el registro correctamente.", NotificationSeverity.Success);
                await GoFirstTab.InvokeAsync();
                return;
            }
            else
            {
                var error = resPost.ErrorMessage();
                NotificationService.Notify(error, NotificationSeverity.Error);
            }
        }
        catch (Exception e)
        {
            NotificationService.Notify(e.Message, NotificationSeverity.Error);
        }
        finally
        {
            LoadingData = false;
        }
    }

    void OnInvalidSubmit()
    {
        StatusClass = "alert-danger";
        NotificationService.Notify("Validaciones pendientes.", NotificationSeverity.Error);
    }

    void ShowTooltip(ElementReference elementReference, string text)
    {
        tooltipService.ShowToolTip(elementReference, text);
    }
}
